#ifndef zetsubou_Draw
#define zetsubou_Draw
//Making a tree from datafile, Drawing 1-D Histram and 2-D Scatter diagram 
Bool_t zetsubou::MakeCanvas(const Char_t *name,Int_t canvasstyle)
{
  std::string Cnum;//canvas number
  std::string preCName = name;
  Cnum=preCName.substr(1);
  preCName.replace(0,1,"c");//I want canvas name to be "c0","c1",.....
  std::string discri;
  std::string CName;
  Char_t buf[10];
  for(Int_t i=0;i<=10;i++)//in this loop,checking sCName is "c0","c1"...,if not user input canvas name from the console
  {
	std::sprintf(buf,"c%d",i);//buf = "c0","c1"...
	discri = buf;
	if(std::string(name) == discri)//if histname or scatname is "c1","c2","c3", it should not be equall to canvasname
	{
		std::cout << "Please Input Canvas-Name:" ;
		std::cin >> CName; 
		if(!std::cin) std::exit(1);		
		break;
	}
	if(discri == preCName)
	{
		CName = preCName;		
		break;
	}
	if(i == 10)
	{
		std::cout << "Please Input Canvas-Name:" ;
		std::cin >> CName;
		if(!std::cin) std::exit(1);		
	}
  }
  //corresponding to  canvas number,canvas position change.
  Int_t canvas_positionX = 60*std::atoi(Cnum.c_str());
  Int_t canvas_positionY = 30*std::atoi(Cnum.c_str());
  if(canvasstyle == HIST) 
  canvas = new TCanvas(CName.c_str(),CName.c_str(),canvas_positionX,canvas_positionY,Hist_canvas_width,Hist_canvas_length);
  if(canvasstyle == SCAT) 
  canvas = new TCanvas(CName.c_str(),CName.c_str(),canvas_positionX,canvas_positionY,Scat_canvas_width,Scat_canvas_length);
  return true;
}

Bool_t zetsubou::MakeTree(const Char_t *filename)
{
  UShort_t  buf[4];
  std::FILE *fp;
  fp = fopen(filename, "rb");
  if(fp == NULL) 
  {
	std::cout<<"絶望した！ファイルが開けなくて絶望した！"<<std::endl;
	return false;
  } 
  currentfname=filename;
  delete tr;  
  tr = new TTree("tr","tr");
  tr->SetDirectory(0); // not to leave a obj::TTree in memory 
  tr->Branch("E", &buf[1], "E/s");//"s" mean "a 16 bit of unsigned short integer"
  tr->Branch("dE",&buf[2], "dE/s");
  while (1) 
  {
	if (fread(buf,2,4,fp) < 1) break;
	tr->Fill();
  }
  fclose(fp);
  
  return true;
}

TH1D *zetsubou::DrawHist(const Char_t *filename,const Char_t *title,const Char_t *type,const Char_t *histname,Int_t nbin,Double_t xmin,Double_t xmax,Int_t cutmin,Int_t cutmax)
{
  std::string tmpfname=filename; //temporary file name
  Bool_t isTree = true; //for checking there is a same tree
  if(tmpfname != currentfname) 
  {
	isTree = MakeTree(filename); //making Tree unless same Tree already has been made
  }
  if(!isTree) return 0;

  if(hist)
  {	//string(something):converting something to string type
	if(std::string(hist->GetName()) == std::string(histname))
	{
	delete hist;//if there was a hist that had same name,it must be deleted
	hist=0;
	}
  }
  
  Char_t trdraw[100];
  Char_t trcutL[1000];
  Char_t trcutR[100];
  std::sprintf(trdraw,"%s>>%s",type,histname);//E>>hist or dE>>hist
  MakeCanvas(histname,HIST);
  if(whichstyle  == SCAT) SetHistStyle();  
  hist = new TH1D(histname,title,nbin,xmin,xmax);
  if(type == std::string("E"))
  {
	if(cutmin == 0 && cutmax == 0)
	{
		tr->Draw(trdraw,"E>=0 & dE>=0");
	}
	else
	{
		std::sprintf(trcutL,"dE >= %i &",cutmin);
		std::sprintf(trcutR,"dE < %i "  ,cutmax);
		std::strcat(trcutL,trcutR); //dE >= cutmin &dE < cutmax
		tr->Draw(trdraw,trcutL);
	}
	hist->GetXaxis()->SetTitle("E-counter");
  }
  if(type == std::string("dE"))
  {
	if(cutmin == 0 && cutmax == 0)
	{
		tr->Draw(trdraw,"");
	}
	else
	{
		std::sprintf(trcutL,"E >= %i &",cutmin);
		std::sprintf(trcutR,"E < %i "  ,cutmax);
		std::strcat(trcutL,trcutR); //E >= cutmin &E < cutmax
		tr->Draw(trdraw,trcutL);
	}
	hist->GetXaxis()->SetTitle("#DeltaE-counter");  
  }
  
  return hist;
}

//you can omit Tcut
TH1D *zetsubou::DrawHist(const Char_t *filename,const Char_t *title,const Char_t *type,const Char_t *histname,Int_t nbin,Double_t xmin,Double_t xmax)
{ 
  DrawHist(filename,title,type,histname,nbin,xmin,xmax,0,0);
  
  return hist;
}

//you can omit title
TH1D *zetsubou::DrawHist(const Char_t *filename,const Char_t *type,const Char_t *histname,Int_t nbin,Double_t xmin,Double_t xmax,Int_t cutmin,Int_t cutmax)
{ 
  std::string tmpfname=filename;
  if(tmpfname == currentfname) {}//this is necessary but I don't know why  

  std::string ss = std::string(filename);
  std::string stitle =ss.erase(7);
  DrawHist(filename,stitle.c_str(),type,histname,nbin,xmin,xmax,cutmin,cutmax);
  
  return hist;
}

//you can omit title and Tcut
TH1D *zetsubou::DrawHist(const Char_t *filename,const Char_t *type,const Char_t *histname,Int_t nbin,Double_t xmin,Double_t xmax)
{
  std::string ss = std::string(filename);
  std::string stitle =ss.erase(7);
  DrawHist(filename,stitle.c_str(),type,histname,nbin,xmin,xmax,0,0);
 
  return hist;
}

//for oblique cut 
TH1D *zetsubou::HistCut(Double_t X1,Double_t Y1,Double_t X2,Double_t Y2,Double_t X3,Double_t Y3,Double_t X4,Double_t Y4)
{
  if(!hist) return 0;

  Char_t cutline1[100];//under border
  Char_t cutline2[100];//right border
  Char_t cutline3[100];//top border
  Char_t cutline4[100];//left border
  if(X1 == X2 || X3 == X4) 
  {
	std::cout << "その切り方、絶望的!" << std::endl;
	return 0;
  }
  std::sprintf(cutline1,"dE >= %f*E +  %f",(Y2-Y1) / (X2-X1) ,Y1 - ((Y2-Y1) / (X2-X1))*X1 );
  std::sprintf(cutline3,"dE <= %f*E + %f",(Y3-Y4) / (X3-X4) ,Y4 - ((Y3-Y4) / (X3-X4))*X4 );
  
  if(X2 < X3) {std::sprintf(cutline2,"dE >= %f*E + %f",(Y3-Y2) / (X3-X2) ,Y2 - ((Y3-Y2) / (X3-X2))*X2 );}
  if(X2 > X3) {std::sprintf(cutline2,"dE <= %f*E + %f",(Y3-Y2) / (X3-X2) ,Y2 - ((Y3-Y2) / (X3-X2))*X2 );}
  if(X2 == X3){std::sprintf(cutline2,"E <= %f",X3);}
  
  
  if(X1 < X4) {std::sprintf(cutline4,"dE <= %f*E + %f",(Y4-Y1) / (X4-X1) ,Y1 - ((Y4-Y1) / (X4-X1))*X1 );}
  if(X1 > X4) {std::sprintf(cutline4,"dE >= %f*E + %f",(Y4-Y1) / (X4-X1) ,Y1 - ((Y4-Y1) / (X4-X1))*X1 );}
  if(X1 == X4){std::sprintf(cutline4,"E >= %f",X1);}
 
  std::string  totalcut;
  totalcut = cutline1 +std::string("&&")+ cutline2 +"&&"+ cutline3+ "&&" + cutline4;
  std::cout << "----- border line -----" << std::endl;
  std::cout << "under: " << cutline1 << std::endl;
  std::cout << "right: " << cutline2 << std::endl;
  std::cout << "top: " << cutline3 << std::endl;
  std::cout << "left: "  << cutline4 << std::endl;
  
  Char_t trdraw[100];
  std::sprintf(trdraw,"E >> %s",(hist->GetName()));
  tr->Draw(trdraw,totalcut.c_str());
  return hist;	
}

TH2D *zetsubou::DrawScat(const Char_t *filename,const Char_t *title,const Char_t *scatname)
{
  std::string tmpfname=filename;//temporary file name
  Bool_t isTree = true;//for checking there is same tree
  if(tmpfname != currentfname)
  {
	isTree = MakeTree(filename);
  }				//making Tree unless same Tree already has been made
  if(!isTree) return 0;
  
  if(scat) 
  {
	if(std::string (scat->GetName()) == std::string (scatname) ) 
	{  
	delete scat;
	scat=0;
	}
  }//if there was a scat that had same name,it must be deleted
  MakeCanvas(scatname,SCAT);
  if(whichstyle == HIST) SetScatStyle();
  canvas->Divide(2,2);
  
  canvas->cd(1);
  hist = new TH1D("px","",128,0,4095);
  tr->Draw("E>>px","");
  
  canvas->cd(2);
  hist = new TH1D("py","", 128 ,0,4095);
  tr->Draw("dE>>py","");
  
  canvas->cd(3);
  Char_t trdraw[100]; 
  std::sprintf(trdraw,"dE:E >>%s",scatname);
  scat = new TH2D(scatname,title,1024,0,4095,1024,0,4095);
  tr->Draw(trdraw,"");
  scat->GetXaxis()->SetTitle("E");
  scat->GetYaxis()->SetTitle("#DeltaE");
    
  return scat;
}

//you can omit title
TH2D *zetsubou::DrawScat(const Char_t *filename,const Char_t *scatname)
{
  std::string ss = std::string(filename);
  std::string stitle =ss.erase(7);
  DrawScat(filename,stitle.c_str(),scatname);

  return scat;
}

TH2D *zetsubou::DrawScat(const Char_t *filename,const Char_t *title,const Char_t *scatname,Int_t xmin, Int_t xmax,Int_t ymin,Int_t ymax)
{
  std::string tmpfname=filename;
  Bool_t isTree = true;
  if(tmpfname != currentfname)
  {
	isTree = MakeTree(filename);
  }				
  if(!isTree) return 0;
  
  MakeCanvas(scatname,SCAT);  
  if(whichstyle == HIST) SetScatStyle(); 
  
  if(scat) 
  {
	if(std::string (scat->GetName()) == std::string (scatname))
	{
	delete scat;
	scat=0;
	}
  } 
  
  Char_t trcut[100]; 
  std::sprintf(trcut,"E>=%i & E<%i & dE>=%i & dE<%i",xmin,xmax,ymin,ymax);
  canvas->Divide(2,2);
  
  canvas->cd(1);
  tr->Draw("E",trcut);
  
  canvas->cd(2);
  tr->Draw("dE",trcut);
  canvas->UseCurrentStyle();
  
  canvas->cd(3);
  Char_t trdraw[100]; 
  std::sprintf(trdraw,"dE:E >>%s",scatname);
  scat = new TH2D(scatname,title,1024,0,4095,1024,0,4095);
  tr->Draw(trdraw,"");
  scat->GetXaxis()->SetTitle("E");
  scat->GetYaxis()->SetTitle("#DeltaE");

  canvas->cd(4);  
  tr->Draw("dE:E",trcut);
  scat->GetXaxis()->SetTitle("E");
  scat->GetYaxis()->SetTitle("#DeltaE");
  return scat;
}

//you can omit title
TH2D *zetsubou::DrawScat(const Char_t *filename,const Char_t *scatname,Int_t xmin, Int_t xmax,Int_t ymin,Int_t ymax)
{
  std::string ss = std::string(filename);
  std::string stitle =ss.erase(7);
  DrawScat(filename,stitle.c_str(),scatname,xmin,xmax,ymin,ymax);

  return scat;
}
#endif //Draw.h
